#include <bits/stdc++.h>
using namespace std;
using T = int;

int main() {
    ios::sync_with_stdio(0);
    cout.tie();
    cin.tie();
    T n,m,t,z=0,q,c;
    cin >> n >> m >> t;
    vector<T>A(n);
    for (T i=0;i<n;i++){
        cin >>A[i];
    }
    vector<vector<T>>dp(n+2,vector<T>(50+3,0));
    for (T i=0;i<m;i++){
        cin >>c;
        if (A[c-1]<=t){
            dp[c][A[c-1]]=1;
            z=max(z,t/A[c-1]);
        }
    }
    for (T j=0;j<50+3;j++){
        for (T i=1;i<n+1;i++){
            if (j>=A[i-1]){
                q=max(dp[i-1][j-A[i-1]], max(dp[i+1][j-A[i-1]],dp[i][j-A[i-1]]));
                if (q>0){
                    q+=1;
                    dp[i][j]=q;
                    z=max(z,q*(t/j));
                }
            }

        }
    }
    cout << z;
    return 0;
}
